package test;

import java.sql.Connection;
import java.sql.SQLException;

import org.junit.jupiter.api.AfterAll;
import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.BeforeAll;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;

public class TriggerATest {

    private static Connection con = null; // direkte DB-Verbindung
    private Basisdaten basisdaten = new Basisdaten();

    @BeforeAll
    public static void setUpBeforeClass() throws Exception {
        con = Verbindung.verbinden();
    }

    @AfterAll
    public static void tearDownAfterClass() throws Exception {
        Verbindung.verbindungTrennen(con);
    }

    @BeforeEach
    public void setUp() throws Exception {
        basisdaten.initialisieren(con);
    }

    @Test
    public void testLetzePruefungenLoeschenOk1() {
        try {
            int anzahl = con.createStatement()
                    .executeUpdate("DELETE FROM Pruefung "
                            + "WHERE matnr=444 AND mid=11 AND versuch=1");
            Assertions.assertTrue(anzahl == 1
                , "statt 1, " + anzahl + "Datensaetze geaendert");
        } catch (SQLException e) {
            Assertions.fail("Pruefung loeschbar: "
                    + "matnr=444 AND mid=11 AND versuch=1");
        }
    }

    @Test
    public void testLetzePruefungenLoeschenOk2() {
        try {
            int anzahl = con.createStatement()
                    .executeUpdate("DELETE FROM Pruefung "
                            + "WHERE matnr=444 AND mid=12 AND versuch=2");
            Assertions.assertTrue(anzahl == 1
                , "statt 1, " + anzahl + "Datensaetze geaendert");
        } catch (SQLException e) {
            Assertions.fail("Pruefung loeschbar: "
                    + "matnr=444 AND mid=12 AND versuch=2");
        }
    }

    @Test
    public void testLetzePruefungenLoeschenOk3() {
        try {
            int anzahl = con.createStatement()
                    .executeUpdate("DELETE FROM Pruefung "
                            + "WHERE matnr=449 AND mid=11 AND versuch=3");
            Assertions.assertTrue(anzahl == 1
               , "statt 1, " + anzahl + "Datensaetze geaendert");
        } catch (SQLException e) {
            Assertions.fail("Pruefung loeschbar, da nicht letzte: "
                    + "matnr=449 AND mid=11 AND versuch=3");
        }
    }

    @Test
    public void testLetzePruefungenLoeschenNichtOk1() {
        try {
            con.createStatement()
                    .executeUpdate("DELETE FROM Pruefung "
                            + "WHERE matnr=444 AND mid=12 AND versuch=1");
            Assertions.fail("Pruefung nicht loeschbar, da nicht letzte: "
                    + "matnr=444 AND mid=12 AND versuch=1");
        } catch (SQLException e) {
        }
    }

    @Test
    public void testLetzePruefungenLoeschenNichtOk2() {
        try {
            con.createStatement()
                    .executeUpdate("DELETE FROM Pruefung "
                            + "WHERE matnr=449 AND mid=11 AND versuch=2");
            Assertions.fail("Pruefung nicht loeschbar, da nicht letzte: "
                    + "matnr=449 AND mid=11 AND versuch=2");
        } catch (SQLException e) {
        }
    }

}
