package test;

import java.sql.Connection;
import java.sql.SQLException;

import org.junit.jupiter.api.AfterAll;
import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.BeforeAll;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;

public class TriggerCTest {

    private static Connection con = null; // direkte DB-Verbindung
    private Basisdaten basisdaten = new Basisdaten();

    @BeforeAll
    public static void setUpBeforeClass() throws Exception {
        con = Verbindung.verbinden();
    }

    @AfterAll
    public static void tearDownAfterClass() throws Exception {
        Verbindung.verbindungTrennen(con);
    }

    @BeforeEach
    public void setUp() throws Exception {
        basisdaten.initialisieren(con);
    }

    @Test
    public void testNeuePruefungOk1() {
        int matnr = 445;
        int mid = 32;
        String datum = "'2015-01-01'";
        int versuch = 1;
        int note = 100;
        try {
            int anzahl = con.createStatement()
                    .executeUpdate(
                            "INSERT INTO Pruefung VALUES("
                            + matnr + "," + mid + "," + datum + "," + versuch + "," + note + ")"
                    );
            Assertions.assertTrue(anzahl == 1
                , "statt 1, " + anzahl + "Datensaetze geaendert");
        } catch (SQLException e) {
            Assertions.fail("neue Pruefung ist ok, aber nicht eingefuegt: "
                    + matnr + "," + mid + "," + datum + "," + versuch + "," + note);
        }
    }

    @Test
    public void testNeuePruefungOk2() {
        int matnr = 445;
        int mid = 12;
        String datum = "'2015-01-01'";
        int versuch = 3;
        int note = 500;
        try {
            int anzahl = con.createStatement()
                    .executeUpdate(
                            "INSERT INTO Pruefung VALUES("
                            + matnr + "," + mid + "," + datum + "," + versuch + "," + note + ")"
                    );
            Assertions.assertTrue(anzahl == 1
                , "statt 1, " + anzahl + "Datensaetze geaendert");
        } catch (SQLException e) {
            Assertions.fail("neue Pruefung ist ok, aber nicht eingefuegt: "
                    + matnr + "," + mid + "," + datum + "," + versuch + "," + note);
        }
    }
    

    @Test
    public void testNeuePruefungOk3() {
        int matnr = 451;
        int mid = 12;
        String datum = "'2015-01-01'";
        int versuch = 1;
        int note = 100;
        try {
            int anzahl = con.createStatement()
                    .executeUpdate(
                            "INSERT INTO Pruefung VALUES("
                            + matnr + "," + mid + "," + datum + "," + versuch + "," + note + ")"
                    );
            Assertions.assertTrue(anzahl == 1
                , "statt 1, " + anzahl + "Datensaetze geaendert");
        } catch (SQLException e) {
            Assertions.fail("neue Pruefung ist ok, aber nicht eingefuegt: "
                    + matnr + "," + mid + "," + datum + "," + versuch + "," + note);
        }
    }

    @Test
    public void testNeuePruefungNichtOk1() {
        int matnr = 450;
        int mid = 21;
        String datum = "'2015-01-01'";
        int versuch = 1;
        int note = 500;
        try {
            con.createStatement()
                    .executeUpdate(
                            "INSERT INTO Pruefung VALUES("
                            + matnr + "," + mid + "," + datum + "," + versuch + "," + note + ")"
                    );
            Assertions.fail("Pruefung eingefuegt, die nicht ok ist, da endgueltig durchgefallen: "
                    + matnr + "," + mid + "," + datum + "," + versuch + "," + note);
        } catch (SQLException e) {
        }
    }

    @Test
    public void testNeuePruefungNichtOk2() {
        int matnr = 449;
        int mid = 31;
        String datum = "'2015-01-01'";
        int versuch = 1;
        int note = 500;
        try {
            con.createStatement()
                    .executeUpdate(
                            "INSERT INTO Pruefung VALUES("
                            + matnr + "," + mid + "," + datum + "," + versuch + "," + note + ")"
                    );
            Assertions.fail("Pruefung eingefuegt, die nicht ok ist, da nicht genuegend Leistungspunkte fuer Drittsemesterpruefung: "
                    + matnr + "," + mid + "," + datum + "," + versuch + "," + note);
        } catch (SQLException e) {
        }
    }

    @Test
    public void testNeuePruefungNichtOk3() {
        int matnr = 449;
        int mid = 21;
        String datum = "'2015-01-01'";
        int versuch = 2;
        int note = 500;
        try {
            con.createStatement()
                    .executeUpdate(
                            "INSERT INTO Pruefung VALUES("
                            + matnr + "," + mid + "," + datum + "," + versuch + "," + note + ")"
                    );
            Assertions.fail("Pruefung eingefuegt, die nicht ok ist, da noch kein erster Versuch fuer das Modul eingetragen: "
                    + matnr + "," + mid + "," + datum + "," + versuch + "," + note);
        } catch (SQLException e) {
        }
    }

    @Test
    public void testNeuePruefungNichtOk4() {
        int matnr = 446;
        int mid = 22;
        String datum = "'2015-01-01'";
        int versuch = 3;
        int note = 500;
        try {
            con.createStatement()
                    .executeUpdate(
                            "INSERT INTO Pruefung VALUES("
                            + matnr + "," + mid + "," + datum + "," + versuch + "," + note + ")"
                    );
            Assertions.fail("Pruefung eingefuegt, die nicht ok ist, da noch kein zweiter Versuch fuer das Modul eingetragen: "
                    + matnr + "," + mid + "," + datum + "," + versuch + "," + note);
        } catch (SQLException e) {
        }
    }

    @Test
    public void testNeuePruefungNichtOk5() {
        int matnr = 446;
        int mid = 22;
        String datum = "'2013-10-11'";
        int versuch = 2;
        int note = 500;
        try {
            con.createStatement()
                    .executeUpdate(
                            "INSERT INTO Pruefung VALUES("
                            + matnr + "," + mid + "," + datum + "," + versuch + "," + note + ")"
                    );
            Assertions.fail("Pruefung eingefuegt, die nicht ok ist, da Datum vor dem Datum des ersten Versuchs liegt: "
                    + matnr + "," + mid + "," + datum + "," + versuch + "," + note);
        } catch (SQLException e) {
        }
    }

    @Test
    public void testNeuePruefungNichtOk6() {
        int matnr = 446;
        int mid = 23;
        String datum = "'2015-01-01'";
        int versuch = 2;
        int note = 500;
        try {
            con.createStatement()
                    .executeUpdate(
                            "INSERT INTO Pruefung VALUES("
                            + matnr + "," + mid + "," + datum + "," + versuch + "," + note + ")"
                    );
            Assertions.fail("Pruefung eingefuegt, die nicht ok ist, da das Modul bereits im vorherigen Versuch bestanden wurde: "
                    + matnr + "," + mid + "," + datum + "," + versuch + "," + note);
        } catch (SQLException e) {
        }
    }

}
